
#ifndef _ROBERT_BLE_H
#define _ROBERT_BLE_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/event_groups.h"
#include "esp_system.h"
#include "esp_log.h"
#include "nvs_flash.h"
#include "esp_bt.h"

#include "esp_gap_ble_api.h"
#include "esp_gatts_api.h"
#include "esp_bt_defs.h"
#include "esp_bt_main.h"
#include "esp_gatt_common_api.h"
#include "Robert_PublicFile.h"

#define GATTS_TAG "GATTS_DEMO"

// #define TEST_DEVICE_NAME            "IMS5-BA2-"
#define TEST_MANUFACTURER_DATA_LEN  17

#define GATTS_DEMO_CHAR_VAL_LEN_MAX 0x40

#define PREPARE_BUF_MAX_SIZE 1024

#define PROFILE_NUM   1
#define PROFILE_A_APP_ID   0
// #define PROFILE_B_APP_ID 1

#define GATTS_SERVICE_UUID_TEST_A   0x00FF
#define GATTS_CHAR_UUID_TEST_A      0xFF01
#define GATTS_DESCR_UUID_TEST_A     0x3333
#define GATTS_NUM_HANDLE_TEST_A     4

// #define GATTS_SERVICE_UUID_TEST_B   0x00EE
// #define GATTS_CHAR_UUID_TEST_B      0xEE01
// #define GATTS_DESCR_UUID_TEST_B     0x2222
// #define GATTS_NUM_HANDLE_TEST_B     4


#define adv_config_flag      (1 << 0)
#define scan_rsp_config_flag (1 << 1)

extern char* device_name;

typedef struct {
    uint8_t                 *prepare_buf;
    int                     prepare_len;
} prepare_type_env_t;

void gap_event_handler(esp_gap_ble_cb_event_t event, esp_ble_gap_cb_param_t *param);
void example_write_event_env(esp_gatt_if_t gatts_if, prepare_type_env_t *prepare_write_env, esp_ble_gatts_cb_param_t *param);
void example_exec_write_event_env(prepare_type_env_t *prepare_write_env, esp_ble_gatts_cb_param_t *param);

void gatts_event_handler(esp_gatts_cb_event_t event, esp_gatt_if_t gatts_if, esp_ble_gatts_cb_param_t *param);
void Robert_NVS_Init();
void Robert_BLE_Init(void);
void nvs_read_data_from_flash();
void nvs_write_data_to_flash(uint8_t *buff);
void read_data_analysis(uint8_t *buff);
void nvs_write_null_to_flash();
void writeData();
void GenerateStr(void );
void Robert_ble_SendData(uint8_t *buff,uint len);
void Robert_writeFlash();
void Robert_BLEAnalysis(esp_ble_gatts_cb_param_t *param);

#endif