#ifndef _ROBERT_PUBLICFILE_H
#define _ROBERT_PUBLICFILE_H

#include <string.h>
#include <stdio.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/semphr.h"
#include "esp_log.h"
#include "Robert_BLE.h"
#include "driver/adc.h"
#include "Robert_timer.h"
#include "Robert_gpio.h"
#include "Robert_ADC.h"


#define DATA_Lenth  24

#define Device_name_log "Device_name"
#define ADCTAG "ADCSignal_DEMO"
#define LD2_Time 6            //LD2,数值为2的倍数，越大，每秒闪的次数越少
#define advertisingtime  6 //2min

#define MAIN_LOG "main_log"

char* TEST_DEVICE_NAME;

extern uint8_t write_data_buff[DATA_Lenth];

extern int16_t I_buffer[3];
extern int16_t Q_buffer[3];

extern uint8_t Gear;        // 档位
extern uint16_t Keeptime;   // 保持时间
extern uint8_t Direction;   // 方向
extern uint8_t DeviceNameSet[20]; //设备名称
extern char RandStr[20];  //随机名或固定数组

extern uint8_t writeFlg;   // 保存数据标志：0不保存； 1：保存数据

extern uint8_t OUTPUT_ind;
extern uint8_t Sensor_ind;

extern uint8_t ConnectedFlag;

extern uint32_t advertisingtimeCount;
extern uint8_t advertisingFlag;
extern uint8_t CloseFlg;
extern uint16_t updateStatusTime;

extern uint8_t Near_CNT;                          //靠近信号计数
extern uint8_t Near_Time;                          //靠近信号定时
extern uint8_t Near_Tx_update;                     //靠近
extern uint8_t Near_Tx_Time;                      //靠近
extern uint8_t Leave_CNT_A;                      //远离信号计数A
extern uint8_t Leave_CNT_B;                       //远离信号计数B
extern uint8_t Leave_Time_A;                      //远离信号定时A
extern uint8_t Leave_Time_B;                      //远离信号定时B
extern uint8_t Leave_Time_C;                      //远离信号定时C
extern uint8_t Leave_Time_D;                      //远离信号定时D
extern uint8_t Leave_Time_E;                      //远离信号定时E
extern uint8_t Leave_Tx_update;                   //远离
extern uint8_t Leave_Tx_Time;                      //远离  
extern uint8_t Near_L_CNT;                          //用远离门限计算靠近信号计数，用于清除远离信号误报的问题(低档位出现误报问题）
extern uint8_t Near_L_Time;                          //用远离门限计算靠近信号定时，用于清除远离信号误报的问题(低档位出现误报问题） 

/*----光耦继电器输出变量-----*/
extern uint8_t Output_Sign;                   //
extern uint32_t Output_Time;                      //

/*----LED_Sensor变量-----*/
extern uint8_t LED_Sensor_Time;
extern uint8_t TX_time;                            //用于定时200mS，发送数据

// 目前包括定时器
void Stop_All_ISR(void);
void Start_All_ISR(void);

void IQhandle();
void mainloop();
void OUTPUT_L();
void OUTPUT_H();
void threshold_Init();


#endif
